package mmc;

/**
 * class contains functions necessary for the calculation of decay
 */

public class Decay extends CrossSections implements DFunctionOfx{


    private FindRoot f;

    /**
     * creates internal references to p and m
     */

    public Decay(CrossSections cros){
	super(cros);
	f = new FindRoot(40, 1.e-6);
    }

    //----------------------------------------------------------------------------------------------------//

    /**
     * this cross section describes decay
     */

    public double decay(){
	return 1/((p.p/p.m)*p.l*C);
    }

    //----------------------------------------------------------------------------------------------------//

    /**
     * energy of the electron that results from the muon decay
     */

    public double e(double ernd, double arnd){
	double emax, x0, f0, el;
	emax=(p.m*p.m+Me*Me)/(2*p.m);
	x0=Me/emax;
	f0=x0*x0;
	f0=f0*x0-f0*f0/2;
	el=Math.max(f.findRoot(x0, 1, 0.5, this, f0+(0.5-f0)*ernd)*emax, Me);
	return el*(p.e/p.m)+Math.sqrt(el*el-Me*Me)*(p.p/p.m)*(2*arnd-1);
    }

    //----------------------------------------------------------------------------------------------------//

    /**
     * function for electron energy calculation - interface to FindRoot
     */

    public double function(double x){
	double x2;
	x2=x*x;
	return x*x2-x2*x2/2;
    }

    //----------------------------------------------------------------------------------------------------//

    /**
     * function for electron energy calculation - interface to FindRoot
     */

    public double dFunction(double x){
	return (3-2*x)*x*x;
    }

}
